from spidr4 import rpc
import helpers

if __name__ == '__main__':
    # Parse command-line
    ns = helpers.cl_parse(with_chip_idx=False)

    # Main loop, create network connection
    with helpers.cl_connect() as channel:
        # Get the services
        prpl = rpc.PeripheralStub(channel)
        dps = prpl.GetSenseData(rpc.EMPTY)

        t2f = {
            rpc.BOOLEAN: ("{val!s}", lambda x: x.bool_value),
            rpc.FLOAT:   ("{val:.2f}", lambda x: x.float_value),
            rpc.INT:     ("{val:d}", lambda x: x.int_value)
        }

        si = sorted(dps.items, key=lambda x : x.id)
        print(f"{'DataPoint ID':<32s} Valid {'Value':>15s}")
        for dp in si:
            vc = dp.value
            conv = t2f[vc.type]
            valstr = conv[0].format(val=conv[1](vc))
            print(f"{dp.id:<32s} {dp.valid!s:5s} {valstr:>15s}")